var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
import { Loading } from "element-ui";
import Vue, { defineComponent, h } from "vue";
class PaginationConfig {
  constructor({ pageSize, currentPage }) {
    __publicField(this, "currentPage", 1);
    __publicField(this, "pageSize", 10);
    __publicField(this, "total", 0);
    if (pageSize && !isNaN(pageSize) && typeof pageSize === "number" && pageSize > 0) {
      this.pageSize = pageSize;
    }
    if (currentPage && !isNaN(currentPage) && typeof currentPage === "number" && currentPage > 0) {
      this.currentPage = currentPage;
    }
  }
  getParams() {
    const page = (this.currentPage || 1) - 1;
    return {
      from: page * this.pageSize,
      page,
      size: this.pageSize
    };
  }
  filterData(arr) {
    const { from, size } = this.getParams();
    return arr.slice(from, from + size);
  }
}
const loadingList = [];
let loadingInstance = null;
const $loading = {
  increase(options = { fullscreen: true }) {
    loadingInstance = Loading.service(options);
    loadingList.push(1);
  },
  decrease() {
    setTimeout(() => {
      loadingList.pop();
      if (loadingList.length === 0) {
        loadingInstance.close();
      }
    });
  }
};
function isVueOptions(options) {
  if (!options) {
    return false;
  }
  return typeof options.template === "string" || typeof options.render === "function";
}
var _sfc_main = defineComponent({
  name: "SharpModal",
  props: {
    title: {
      type: [String, Object, Vue],
      default: () => void 0
    },
    width: {
      type: String,
      default: () => "500px"
    },
    data: {
      type: Object,
      default: () => {
      }
    },
    component: {
      type: [Object, Vue],
      default: () => void 0
    },
    elProps: {
      type: Object,
      default: () => {
      }
    },
    modalResolve: {
      type: Function,
      default: () => void 0
    },
    footer: {
      type: [Object, Vue],
      default: () => void 0
    },
    footerAlign: {
      type: String,
      default: "right"
    },
    cancelBtn: {
      type: [Object],
      default: () => ({ text: "\u53D6\u6D88" })
    },
    okBtn: {
      type: [Object],
      default: () => ({ text: "\u786E\u8BA4" })
    }
  },
  data: () => {
    return {
      visible: false,
      loading: false,
      resultValue: void 0,
      isOk: false
    };
  },
  computed: {
    titleIsComponent() {
      return isVueOptions(this.title);
    },
    footerIsComponent() {
      return isVueOptions(this.footer);
    },
    bodyInstance() {
      return this.$refs.Body;
    }
  },
  mounted() {
    this.$nextTick(() => this.visible = true);
  },
  methods: {
    onBeforeClose(done) {
      if (!this.bodyInstance.onBeforeClose)
        return done();
      const result = this.bodyInstance.onBeforeClose(this);
      if (result && typeof result.then === "function") {
        Promise.resolve(result).then(done);
      } else {
        done();
      }
    },
    close(value, isOk = false) {
      this.visible = false;
      this.resultValue = value;
      this.isOk = isOk;
    },
    onHidden() {
      if (this.isOk) {
        this.modalResolve(this.resultValue);
      } else {
        this.modalResolve(Promise.reject(this.resultValue == null ? "cancel" : this.resultValue));
      }
    },
    onCancel() {
      if (this.bodyInstance.onCancel) {
        this.bodyInstance.onCancel(this);
      } else {
        this.close("cancel");
      }
    },
    onOk() {
      const result = this.bodyInstance.onOk ? this.bodyInstance.onOk(this) : this.$refs.Body;
      if (result && typeof result.then === "function") {
        this.loading = true;
        Promise.resolve(result).then((value) => this.close(value, true)).finally(() => this.loading = false);
      } else {
        this.close(result);
        this.isOk = true;
      }
    }
  }
});
function normalizeComponent(scriptExports, render2, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render2) {
    options.render = render2;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function(context) {
      context = context || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h2, context) {
        hook.call(context);
        return originalRender(h2, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
var _sfc_render = function render() {
  var _vm = this, _c = _vm._self._c;
  _vm._self._setupProxy;
  return _c("el-dialog", _vm._b({ ref: "Modal", attrs: { "modal-append-to-body": false, "close-on-click-modal": false, "visible": _vm.visible, "before-close": _vm.onBeforeClose, "width": _vm.width, "title": _vm.titleIsComponent ? void 0 : _vm.title }, on: { "update:visible": function($event) {
    _vm.visible = $event;
  }, "closed": _vm.onHidden }, scopedSlots: _vm._u([_vm.titleIsComponent ? { key: "title", fn: function() {
    return [_c(_vm.title, { ref: "Title", tag: "component", attrs: { "modalInstance": this } })];
  }, proxy: true } : null], null, true) }, "el-dialog", _vm.elProps, false), [_c(_vm.component, _vm._b({ ref: "Body", tag: "component", attrs: { "modalInstance": this } }, "component", _vm.data, false)), _vm.footer !== null ? _c("template", { slot: "footer" }, [_vm.footerIsComponent ? [_c(_vm.footer, { ref: "Footer", tag: "component", attrs: { "modalInstance": this } })] : _vm.cancelBtn !== null || _vm.okBtn !== null ? _c("div", { staticClass: "footer-btn-box", style: { textAlign: _vm.footerAlign } }, [_vm.cancelBtn ? _c("el-button", _vm._b({ on: { "click": _vm.onCancel } }, "el-button", _vm.cancelBtn, false), [_vm._v(_vm._s(_vm.cancelBtn.text))]) : _vm._e(), _vm.okBtn ? _c("el-button", _vm._b({ attrs: { "type": "primary", "loading": _vm.loading }, on: { "click": _vm.onOk } }, "el-button", _vm.okBtn, false), [_vm._v(_vm._s(_vm.okBtn.text))]) : _vm._e()], 1) : _vm._e()], 2) : _vm._e()], 2);
};
var _sfc_staticRenderFns = [];
var __component__ = /* @__PURE__ */ normalizeComponent(_sfc_main, _sfc_render, _sfc_staticRenderFns, false, null, null, null, null);
var SharpModal = __component__.exports;
let $root;
function initVueInstance() {
  if (!$root) {
    $root = new Vue({
      data: () => {
        return {
          modals: []
        };
      },
      components: {
        SharpModal
      },
      render() {
        return h("div", {
          "class": "vue2-element-extends"
        }, [this.modals.map((attrs) => h("sharp-modal", {
          "attrs": __spreadValues({}, attrs)
        }))]);
      }
    }).$mount();
    document.body.appendChild($root.$el);
    $root.removeInstance = () => {
      document.body.removeChild($root.$el);
      $root.$destroy();
    };
  } else {
    console.error("\u3010error\u3011$root\u5DF2\u5B58\u5728", $root);
  }
}
function $modal(props) {
  if (typeof props.width === "number")
    props.width = props.width + "px";
  if (!props.component)
    throw new TypeError("\u3010error\u3011 component is required");
  if (!$root)
    initVueInstance();
  const modalProp = __spreadProps(__spreadValues({}, props), {
    modalResolve: (value) => value
  });
  return new Promise((resolve) => {
    modalProp.modalResolve = resolve;
    $root.modals.push(modalProp);
  }).finally(() => {
    $root.modals.splice($root.modals.indexOf(modalProp), 1);
  });
}
const install = function(vue, opts = {}) {
};
var index = {
  version: "0.1.0",
  install
};
export { $loading, $modal, PaginationConfig, index as default };
